src/Entity/Pacientes.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;


/**
 * @ORM\Entity(repositoryClass="App\Repository\PacientesRepository")
 * @UniqueEntity(
 *    fields={"dni"},
 *    message="Este DNI ya ha sido cargado"
 * )
 * @ORM\HasLifecycleCallbacks
 */
class Pacientes
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $nombre;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $apellido;

    /**
     * @ORM\Column(type="integer", unique=true)
     */
    private $dni;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $pais;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $provincia;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $localidad;

    /**
     * @ORM\Column(type="string", length=1000)
     */
    private $domicilio;

    /**
     * @ORM\Column(type="date")
     */
    private $fecha_nacimiento;

    /**
     * @ORM\Column(type="boolean")
     */
    private $requiere_internacion;

    /**
     * @ORM\OneToOne(targetEntity="App\Entity\Triages", mappedBy="paciente", cascade={"persist", "remove"})
     */
    private $triage;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Reservas", mappedBy="paciente")
     */
    private $reservas;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $telefono;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $sexo;

    /**
     * @ORM\Column(type="datetime")
     */
    private $createdAt;

    /**
     * @ORM\Column(type="datetime")
     */
    private $updatedAt;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $obraSocial;

    /**
     * @ORM\ManyToMany(targetEntity="App\Entity\Valoraciones", mappedBy="paciente")
     */
    private $valoraciones;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\CuadrosClinicos", mappedBy="paciente")
     */
    private $cuadrosClinicos;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $historialClinico;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Anamnesis", mappedBy="paciente")
     */
    private $anamnesis;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\PrescripcionesOrdenes", mappedBy="paciente")
     */
    private $prescripcionesOrdenes;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Kardecs", mappedBy="paciente")
     */
    private $kardecs;

    public function __construct()
    {
        $this->reservas = new ArrayCollection();
        $this->valoraciones = new ArrayCollection();
        $this->cuadrosClinicos = new ArrayCollection();
        $this->anamnesis = new ArrayCollection();
        $this->prescripcionesOrdenes = new ArrayCollection();
        $this->kardecs = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNombre(): ?string
    {
        return $this->nombre;
    }

    public function setNombre(string $nombre): self
    {
        $this->nombre = $nombre;

        return $this;
    }

    public function getApellido(): ?string
    {
        return $this->apellido;
    }

    public function setApellido(string $apellido): self
    {
        $this->apellido = $apellido;

        return $this;
    }

    public function getDni(): ?int
    {
        return $this->dni;
    }

    public function setDni(int $dni): self
    {
        $this->dni = $dni;

        return $this;
    }

    public function getPais(): ?string
    {
        return $this->pais;
    }

    public function setPais(string $pais): self
    {
        $this->pais = $pais;

        return $this;
    }

    public function getProvincia(): ?string
    {
        return $this->provincia;
    }

    public function setProvincia(string $provincia): self
    {
        $this->provincia = $provincia;

        return $this;
    }

    public function getLocalidad(): ?string
    {
        return $this->localidad;
    }

    public function setLocalidad(string $localidad): self
    {
        $this->localidad = $localidad;

        return $this;
    }

    public function getDomicilio(): ?string
    {
        return $this->domicilio;
    }

    public function setDomicilio(string $domicilio): self
    {
        $this->domicilio = $domicilio;

        return $this;
    }

    public function getFechaNacimiento(): ?\DateTimeInterface
    {
        return $this->fecha_nacimiento;
    }

    public function setFechaNacimiento(\DateTimeInterface $fecha_nacimiento): self
    {
        $this->fecha_nacimiento = $fecha_nacimiento;

        return $this;
    }

    public function getRequiereInternacion(): ?bool
    {
        return $this->requiere_internacion;
    }

    public function setRequiereInternacion(bool $requiere_internacion): self
    {
        $this->requiere_internacion = $requiere_internacion;

        return $this;
    }

    public function getTriage(): ?Triages
    {
        return $this->triage;
    }

    public function __toString()
    {
        return $this->nombre . ' ' . $this->apellido;
    }

    /**
     * @return Collection|Reservas[]
     */
    public function getReservas(): Collection
    {
        return $this->reservas;
    }

    public function addReserva(Reservas $reserva): self
    {
        if (!$this->reservas->contains($reserva)) {
            $this->reservas[] = $reserva;
            $reserva->setPaciente($this);
        }

        return $this;
    }

    public function removeReserva(Reservas $reserva): self
    {
        if ($this->reservas->contains($reserva)) {
            $this->reservas->removeElement($reserva);
            // set the owning side to null (unless already changed)
            if ($reserva->getPaciente() === $this) {
                $reserva->setPaciente(null);
            }
        }

        return $this;
    }

    public function getTelefono(): ?string
    {
        return $this->telefono;
    }

    public function setTelefono(?string $telefono): self
    {
        $this->telefono = $telefono;

        return $this;
    }

    public function getSexo(): ?string
    {
        return $this->sexo;
    }

    public function setSexo(string $sexo): self
    {
        $this->sexo = $sexo;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getUpdatedAt(): ?\DateTimeInterface
    {
        return $this->updatedAt;
    }

    public function setUpdatedAt(\DateTimeInterface $updatedAt): self
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    /**
     * Gets triggered only on insert

     * @ORM\PrePersist
     */
    public function onPrePersist()
    {
        $this->createdAt = new \DateTime("now");
        $this->updatedAt = new \DateTime("now");
    }

    /**
     * Gets triggered every time on update

     * @ORM\PreUpdate
     */
    public function onPreUpdate()
    {
        $this->updatedAt = new \DateTime("now");
    }

    public function getObraSocial(): ?string
    {
        return $this->obraSocial;
    }

    public function setObraSocial(?string $obraSocial): self
    {
        $this->obraSocial = $obraSocial;

        return $this;
    }

    /**
     * @return Collection|Valoraciones[]
     */
    public function getValoraciones(): Collection
    {
        return $this->valoraciones;
    }

    public function addValoracione(Valoraciones $valoracione): self
    {
        if (!$this->valoraciones->contains($valoracione)) {
            $this->valoraciones[] = $valoracione;
            $valoracione->addPaciente($this);
        }

        return $this;
    }

    public function removeValoracione(Valoraciones $valoracione): self
    {
        if ($this->valoraciones->contains($valoracione)) {
            $this->valoraciones->removeElement($valoracione);
            $valoracione->removePaciente($this);
        }

        return $this;
    }

    /**
     * @return Collection|CuadrosClinicos[]
     */
    public function getCuadrosClinicos(): Collection
    {
        return $this->cuadrosClinicos;
    }

    public function addCuadrosClinico(CuadrosClinicos $cuadrosClinico): self
    {
        if (!$this->cuadrosClinicos->contains($cuadrosClinico)) {
            $this->cuadrosClinicos[] = $cuadrosClinico;
            $cuadrosClinico->setPaciente($this);
        }

        return $this;
    }

    public function removeCuadrosClinico(CuadrosClinicos $cuadrosClinico): self
    {
        if ($this->cuadrosClinicos->contains($cuadrosClinico)) {
            $this->cuadrosClinicos->removeElement($cuadrosClinico);
            // set the owning side to null (unless already changed)
            if ($cuadrosClinico->getPaciente() === $this) {
                $cuadrosClinico->setPaciente(null);
            }
        }

        return $this;
    }

    public function getHistorialClinico(): ?string
    {
        return $this->historialClinico;
    }

    public function setHistorialClinico(?string $historialClinico): self
    {
        $this->historialClinico = $historialClinico;

        return $this;
    }

    /**
     * @return Collection|Anamnesis[]
     */
    public function getAnamnesis(): Collection
    {
        return $this->anamnesis;
    }

    public function addAnamnesi(Anamnesis $anamnesi): self
    {
        if (!$this->anamnesis->contains($anamnesi)) {
            $this->anamnesis[] = $anamnesi;
            $anamnesi->setPaciente($this);
        }

src/Form/KardecsType.php
<?php

namespace App\Form;

use App\Entity\Kardecs;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\DateType;

class KardecsType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('fechaIngreso',DateType::class, array('label'=>'Fecha Ingreso','required'=> true, 'widget'=>'single_text','format' => 'dd/MM/yyyy', 'html5'=> false, 'attr'=>array('class' => 'datepicker')))
            ->add('diagnostico')
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Kardecs::class,
        ]);
    }
}

src/Controller/KardecsController.php
<?php

namespace App\Controller;

use App\Entity\Kardecs;
use App\Form\KardecsType;
use App\Repository\KardecsRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Repository\PacientesRepository;

/**
 * @Route("/kardecs")
 */
class KardecsController extends AbstractController
{
    /**
     * @Route("/", name="kardecs_index", methods={"GET"})
     */
    public function index(KardecsRepository $kardecsRepository): Response
    {
        return $this->render('kardecs/index.html.twig', [
            'kardecs' => $kardecsRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="kardecs_new", methods={"GET","POST"})
     */
    public function new(Request $request, PacientesRepository $pacientesRepository): Response
    {
        $paciente = $pacientesRepository->find($request->query->get('paciente'));
        $kardec = new Kardecs();
        $form = $this->createForm(KardecsType::class, $kardec);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $kardec->setPaciente($paciente);
            $kardec->setUsuario($this->getUser());
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($kardec);
            $entityManager->flush();

            return $this->redirectToRoute('kardecs_show', ['id' => $kardec->getId()]);
        }

        return $this->render('kardecs/new.html.twig', [
            'kardec' => $kardec,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="kardecs_show", methods={"GET"})
     */
    public function show(Kardecs $kardec): Response
    {
        return $this->render('kardecs/show.html.twig', [
            'kardec' => $kardec,
        ]);
    }

    // /**
    //  * @Route("/{id}/edit", name="kardecs_edit", methods={"GET","POST"})
    //  */
    // public function edit(Request $request, Kardecs $kardec): Response
    // {
    //     $form = $this->createForm(KardecsType::class, $kardec);
    //     $form->handleRequest($request);
    //
    //     if ($form->isSubmitted() && $form->isValid()) {
    //         $this->getDoctrine()->getManager()->flush();
    //
    //         return $this->redirectToRoute('kardecs_index');
    //     }
    //
    //     return $this->render('kardecs/edit.html.twig', [
    //         'kardec' => $kardec,
    //         'form' => $form->createView(),
    //     ]);
    // }

    /**
     * @Route("/{id}", name="kardecs_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Kardecs $kardec): Response
    {
        if ($this->isCsrfTokenValid('delete'.$kardec->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($kardec);
            $entityManager->flush();
        }

        return $this->redirectToRoute('kardecs_index');
    }
}

templates/kardecs/_delete_form.html.twig
<form method="post" action="{{ path('kardecs_delete', {'id': kardec.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ kardec.id) }}">
    <button class="btn">Delete</button>
</form>

templates/kardecs/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button type="submit" class="btn btn-primary">{{ button_label|default('Guardar') }}</button>
{{ form_end(form) }}

templates/kardecs/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Kardecs{% endblock %}

{% block body %}
    <h1>Edit Kardecs</h1>

    {{ include('kardecs/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('kardecs_index') }}">back to list</a>

    {{ include('kardecs/_delete_form.html.twig') }}
{% endblock %}

templates/kardecs/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Kardecs index{% endblock %}

{% block body %}
    <h1>Kardecs index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>FechaIngreso</th>
                <th>Diagnostico</th>
                <th>CreatedAt</th>
                <th>UpdatedAt</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for kardec in kardecs %}
            <tr>
                <td>{{ kardec.id }}</td>
                <td>{{ kardec.fechaIngreso ? kardec.fechaIngreso|date('Y-m-d') : '' }}</td>
                <td>{{ kardec.diagnostico }}</td>
                <td>{{ kardec.createdAt ? kardec.createdAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>{{ kardec.updatedAt ? kardec.updatedAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>
                    <a href="{{ path('kardecs_show', {'id': kardec.id}) }}">show</a>
                    <a href="{{ path('kardecs_edit', {'id': kardec.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="6">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('kardecs_new') }}">Create new</a>
{% endblock %}

templates/kardecs/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}Nuevo Kardec{% endblock %}

{% block body %}
    <h1>Nuevo Kardec</h1>
    {{ include('kardecs/_form.html.twig') }}
{% endblock %}

{% block javascripts %}
{{parent()}}
<script>
    $(document).ready(function() {
        $('.datepicker').datepicker({
          language: 'es',
          // orientation: 'top',
          useCurrent: false,
          autoclose: true,
          disableTouchKeyboard: true,
          readonly: true
        });
    });
</script>
{% endblock %}

templates/kardecs/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Kardecs{% endblock %}
{% block stylesheets %}
  <link rel="stylesheet" href="{{asset('css/kardecs.css')}}">
{% endblock %}
{% block watermark %}
    <div class="watermarked" data-watermark="{{app.user.username}}"></div>
{% endblock %}
{% block head_css %}
{{parent()}}
  <style media="print">
    @media print{@page {size:legal landscape}}
    @media print
    {
      a { color: black!important; text-decoration: none!important; }
      .table td, .table th { padding: 0.3rem!important; }
      .visible-print  { display: inherit !important; }
      .hidden-print   { display: none !important; }
    }
  </style>
{% endblock %}

{% block body %}
<div class="container">
  <div class="row text-black">
      <div class="col-6">
        <h4>Hoja de Kardec</h4>
      </div>
      <div class="col-6">
        <a class="btn btn-primary btn-sm  d-print-none float-right"
          href="{{ path('kardecs_items_new', {'kardec': kardec.id}) }}">
          <span>
            <i class="fas fa fa-plus"></i>
          </span>
          Agregar Medicamento
        </a>
      </div>
  </div>
</div>
<div class="container border text-black">
  <div class="row">
    <div class="col-4">
      <b>Apellido y Nombre:</b> <a href="{{ path('pacientes_show', {'id': kardec.paciente.id}) }}">{{kardec.paciente.apellido }},{{kardec.paciente.nombre}}</a>
    </div>
    <div class="col-4">
      <b>Fecha de Nacimiento:</b> {{kardec.paciente.fechaNacimiento|date('d/m/Y')}} ({{date("now"|date('d-m-Y')).diff(kardec.paciente.fechaNacimiento).y}} años)
    </div>
    <div class="col-4">
      <b>Fecha de Ingreso:</b> {{kardec.fechaIngreso ? kardec.fechaIngreso|date('d/m/Y')}}
    </div>
  </div>
  <div class="row">
    <div class="col-10">
      <b>Diagnóstico:</b> {{kardec.diagnostico}}
    </div>
    <div class="col-2">
      <b>H. Clínica:</b> {{kardec.paciente.historialClinico}}
    </div>
  </div>
</div>
<div class="row">
  <div class="col-12">
    <table class="table table-fit table-responsive-sm" id="tabla">
      <thead>
        <tr>
          <th rowspan="2" class="border">Medicamento</th>
          <th rowspan="2" class="border">Dosis</th>
          <th rowspan="2" class="border">Vía</th>
          <th rowspan="2" class="border">Horario/s</th>
          <th colspan="10" class="border">Día / Mes / Año</th>
        </tr>
      </thead>
      <tbody>
        {% for item in kardec.kardecsItems %}
          {% set rowspan = 1 %}
          {% if item.historialKardecs and (item.historialKardecs|length > 0) %}
            {% set rowspan = (item.historialKardecs|length / 10)|round(0,'ceil') %}
          {% endif %}
        <tr class="border">
          <td class="border td1" rowspan="{{rowspan}}">
            <a class="btn btn-primary btn-sm  d-print-none"
            href="{{ path('historial_kardecs_new', {'kardecItem': item.id}) }}">
              <span>
                <i class="fas fa fa-plus"></i>
              </span>
            </a>
            {{item.descripcion}}<br>
            <h6><small>{{item.usuario.nombre ~' ' ~ item.usuario.apellido}}</small></h6>
          </td>
          <td class="border" rowspan="{{rowspan}}">{{item.dosis}}</td>
          <td class="border" rowspan="{{rowspan}}">{{item.via}}</td>
          <td class="border" rowspan="{{rowspan}}">
            {{item.horario|date('H:i')}} <br>
            {% set frecuencia = (24 / item.frecuencia) %}
            {% for i in 0..(item.frecuencia - 1) %}
              {% if i != 0 %}
                {{item.horario|date_modify("+"~ frecuencia * i ~"hour")|date('H:i')}} <br>
              {% endif %}
            {% endfor %}
          </td>
          {% if item.historialKardecs %}
            {% for key, item in item.historialKardecs %}
              {% if key <= 9 %}
                <td class="border kardecs"><small>{{item.fecha|date('d/m/')~item.fecha|date('Y')|slice(2, 4)}}<br>{{item.hora|date('H:i')}}<br>{{item.usuario}}</small></td>
              {% endif %}
            {% endfor %}
          {% endif %}
        </tr>
          {% if item.historialKardecs %}
            {% for key, item in item.historialKardecs %}
              {% if key > 9 %}
                {% if key|last == 0 %}
                  <tr>
                {% endif %}
                  <td class="border kardecs"><small>{{item.fecha|date('d/m/')~item.fecha|date('Y')|slice(2, 4)}}<br>{{item.hora|date('H:i')}}<br>{{item.usuario}}</small></td>
                {% if key|last == 9 %}
                  </tr>
                {% endif %}
              {% endif %}
            {% endfor %}
          {% endif %}
        {% endfor %}
      </tbody>
    </table>
  </div>
</div>
{% endblock %}

{% block javascripts %}
 {{parent()}}
 <script>
     Array.from(document.querySelectorAll('.watermarked')).forEach(function(el) {
        el.dataset.watermark = (el.dataset.watermark + ' ').repeat(1800);
      });
 </script>
{% endblock %}